<script>
import { useAuthStore } from '../stores/auth.store';
import { useFieldsDataStore } from '../stores/fields_data.store';
import { usePreviewStore } from '../stores/preview.store';
import { useLayoutIDStore } from '../stores/layout_id.store';
import { useLastSignatureStore } from '../stores/last_signature.store';
import ColumnLayout from './ColumnLayout.vue';
import HorizontalLayout from './HorizontalLayout.vue';

const baseUrl = `${import.meta.env.VITE_API_URL}`;

export default {
    components: {
        ColumnLayout,
        HorizontalLayout
    },
    data() {
        return {
            authStored: useAuthStore(),
            fieldsStored: useFieldsDataStore(),
            previewStored: usePreviewStore(),
            layIDStored: useLayoutIDStore(),
            lastSignatureStored: useLastSignatureStore(),
            formLayout: {
                fullname: '',
                title: '',
                company: '',
                phone: '',
                email: '',
                address: ''
            },
            layouts: [],
            localErros: [],
            chosenLayoutID: 1
        };
    },
    computed: {
        // if user already has signatures, get last created
        lastSignature() {
            const len = this.authStored.user.signatures.length;
            if (len > 0) {
                const last_sig = this.authStored.user.signatures[len - 1];
                this.lastSignatureStored.update(last_sig);
                return last_sig;
            } else {
                return Object;
            }
        }
    },
    methods: {
        // fill form fields from last signature and store it
        updateFormLayout() {
            if (Object.entries(this.lastSignature).length != 0) {
                const filledLayout = {};
                for (const key of Object.keys(this.formLayout)) {
                    filledLayout[key] = this.lastSignature[key];
                }
                this.formLayout = filledLayout;
                this.fieldsStored.update(filledLayout);
            }
        },
        // get all layouts from API
        async fetchLayouts() {
            await this.$axios
                .get(`${baseUrl}/layouts/`)
                .then((resp) => (this.layouts = resp.data))
                .catch((error) => {
                    if (error.response.status == 400) {
                        this.localErros = error.response.data.errors;
                    }
                });
        },
        // set layout id and store it
        storeLay(lay) {
            this.chosenLayoutID = lay.id;
            this.layIDStored.update(this.chosenLayoutID);
        },
        // get fields from forms and layout id and generate preview from API
        async apply() {
            const signatureData = { layout_id: this.chosenLayoutID, ...this.formLayout };
            this.fieldsStored.update(this.formLayout);

            await this.$axios
                .post(`${baseUrl}/layouts_preview/`, {
                    ...signatureData
                })
                .then((resp) => this.previewStored.update(resp.data.html))
                .catch((error) => {
                    if (error.response.status == 400) {
                        this.localErros = error.response.data.errors;
                    }
                });
        }
    },
    mounted() {
        this.updateFormLayout();
        this.fetchLayouts();
    }
};
</script>

<template>
    <el-form label-position="left" label-width="100px" style="max-width: 560px">
        <el-form-item label="Full Name">
            <el-input v-model="formLayout.fullname" />
        </el-form-item>
        <el-form-item label="Title">
            <el-input v-model="formLayout.title" />
        </el-form-item>
        <el-form-item label="Company">
            <el-input v-model="formLayout.company" />
        </el-form-item>
        <el-form-item label="Phone">
            <el-input v-model="formLayout.phone" />
        </el-form-item>
        <el-form-item label="Email">
            <el-input v-model="formLayout.email" />
        </el-form-item>
        <el-form-item label="Address">
            <el-input v-model="formLayout.address" />
        </el-form-item>
    </el-form>
    <div style="align-items: center; justify-content: end; margin-right: -65px">
        <div
            style="
                display: flex;
                align-items: center;
                justify-content: space-evenly;
                padding-bottom: 20px;
            "
        >
            <div v-for="lay in layouts" :class="[lay.name]" @click="storeLay(lay)" :key="lay.id">
                <ColumnLayout v-if="lay.name == 'column'" />
                <HorizontalLayout v-if="lay.name == 'horizontal'" />
            </div>
        </div>
        <div style="display: flex; justify-content: center">
            <el-button @click="apply()">Apply</el-button>
        </div>
    </div>
</template>

<style></style>
